/* *
 * This sample demonstrates handling intents from an Alexa skill using the Alexa Skills Kit SDK (v2).
 * Please visit https://alexa.design/cookbook for additional examples on implementing slots, dialog management,
 * session persistence, api calls, and more.
 * */
const Alexa = require('ask-sdk-core');  
  
const GetRemoteDataHandler = {  
  canHandle(handlerInput) {  
    return handlerInput.requestEnvelope.request.type === 'LaunchRequest'  
      || (handlerInput.requestEnvelope.request.type === 'IntentRequest'  
      && handlerInput.requestEnvelope.request.intent.name === 'GetRemoteDataIntent');  
  },  
   handle(handlerInput) {  
    let outputSpeech = 'Comando executado.';  
  
     getRemoteData('https://ws.ilinq.com.br/html/htmltows.asp?token=pjJ88kjrY8SdU6ThKG40lnKJaC4Tsi18&serial=GT01000004&command=SET:RELAY:ON')  
      .then((response) => {  
        const data = JSON.parse(response);  
        outputSpeech = `There are currently ${data.people.length} astronauts in space. `;  
        for (let i = 0; i < data.people.length; i += 1) {  
          if (i === 0) {  
              
            outputSpeech = `${outputSpeech}Their names are: ${data.people[i].name}, `;  
          } else if (i === data.people.length - 1) {  
              
            outputSpeech = `${outputSpeech}and ${data.people[i].name}.`;  
          } else {  
              
            outputSpeech = `${outputSpeech + data.people[i].name}, `;  
          }  
        }  
      })  
      .catch((err) => {  
        console.log(`ERROR: ${err.message}`);  
          
      });  
  
    return handlerInput.responseBuilder  
      .speak(outputSpeech)  
      .getResponse();  
  },  
};  
  
const HelpIntentHandler = {  
  canHandle(handlerInput) {  
    return handlerInput.requestEnvelope.request.type === 'IntentRequest'  
      && handlerInput.requestEnvelope.request.intent.name === 'AMAZON.HelpIntent';  
  },  
  handle(handlerInput) {  
    const speechText = 'You can introduce yourself by telling me your name';  
  
    return handlerInput.responseBuilder  
      .speak(speechText)  
      .reprompt(speechText)  
      .getResponse();  
  },  
};  
  
const CancelAndStopIntentHandler = {  
  canHandle(handlerInput) {  
    return handlerInput.requestEnvelope.request.type === 'IntentRequest'  
      && (handlerInput.requestEnvelope.request.intent.name === 'AMAZON.CancelIntent'  
        || handlerInput.requestEnvelope.request.intent.name === 'AMAZON.StopIntent');  
  },  
  handle(handlerInput) {  
    const speechText = 'Goodbye!';  
  
    return handlerInput.responseBuilder  
      .speak(speechText)  
      .getResponse();  
  },  
};  
  
const SessionEndedRequestHandler = {  
  canHandle(handlerInput) {  
    return handlerInput.requestEnvelope.request.type === 'SessionEndedRequest';  
  },  
  handle(handlerInput) {  
    console.log(`Session ended with reason: ${handlerInput.requestEnvelope.request.reason}`);  
  
    return handlerInput.responseBuilder.getResponse();  
  },  
};  
  
const ErrorHandler = {  
  canHandle() {  
    return true;  
  },  
  handle(handlerInput, error) {  
    console.log(`Error handled: ${error.message}`);  
  
    return handlerInput.responseBuilder  
      .speak('Sorry, I can\'t understand the command. Please say again.')  
      .reprompt('Sorry, I can\'t understand the command. Please say again.')  
      .getResponse();  
  },  
};  
  
const getRemoteData = (url) => new Promise((resolve, reject) => {  
  const client = url.startsWith('https') ? require('https') : require('http');  
  const request = client.get(url, (response) => {  
    if (response.statusCode < 200 || response.statusCode > 299) {  
      reject(new Error(`Failed with status code: ${response.statusCode}`));  
    }  
    const body = [];  
    response.on('data', (chunk) => body.push(chunk));  
    response.on('end', () => resolve(body.join('')));  
  });  
  request.on('error', (err) => reject(err));  
});  
  
const skillBuilder = Alexa.SkillBuilders.custom();  
  
exports.handler = skillBuilder  
  .addRequestHandlers(  
    GetRemoteDataHandler,  
    HelpIntentHandler,  
    CancelAndStopIntentHandler,  
    SessionEndedRequestHandler,  
  )  
  .addErrorHandlers(ErrorHandler)  
  .lambda();  